#!/system/bin/sh
#
# Copyright (C) 2021-2022 Matt Yang
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
wait_until_login() {

    # in case of /data encryption is disabled
    while [ "$(getprop sys.boot_completed)" != "1" ]; do
        sleep 0.1
    done

    # we doesn't have the permission to rw "/sdcard" before the user unlocks the screen
    # shellcheck disable=SC2039
    local test_file="/sdcard/Android/.PERMISSION_TEST_FREEZEIT"
    true >"$test_file"
    while [ ! -f "$test_file" ]; do
        sleep 2
        true >"$test_file"
    done
    rm "$test_file"
}
init_node_mtk() {
	pm uninstall --user 0 com.mediatek.duraspeed
	killall -9 com.mediatek.duraspeed

	stop aee.log-1-1
	stop vendor_tcpdump
	stop emdlogger
	stop consyslogger
	stop mobile_log_d
	stop wifi_dump
	stop bt_dump
}

init_platform_config() {
	if [ "$(getprop ro.hardware)" != "qcom" ]; then
		init_node_mtk
	fi
}
wait_until_login
mode=`cat /sdcard/Android/yc/uperf/cur_powermode.txt`
if [ $mode = powersave ] || [ $mode = balance ]; then
echo "powersave" > /sdcard/Android/yc/uperf/mode.conf
elif [ $mode = performance ] || [ $mode = fast ]; then
echo "performance" > /sdcard/Android/yc/uperf/mode.conf
fi

chmod 777 /data/adb/modules/uperf/dynamic_monitor
su -c nohup ./dynamic_monitor & 
chmod 777 /data/adb/modules/uperf/test
su -c nohup ./test &
killu() {
	 pids=`ps -e | grep uperf | grep -v grep | awk '{print $2}'`
	 echo $pids
	if [ -n "$pids" ]; then
		kill -9 $pids
	fi
	kill $pids
}
BASEDIR="$(dirname $(readlink -f "$0"))"

crash_recuser() {
    rm $BASEDIR/logcat.log
    logcat -f $BASEDIR/logcat.log &
    sleep 60
    killall logcat
    rm -f $BASEDIR/flag/need_recuser
}

(crash_recuser &)
sh /data/adb/modules/uperf/script/initsvc.sh
stop logcat
